<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>BSI FIDELIO eService: C:/Development/workspaces/adesso/eService/src/de/bund/bsi/fidelio/poc/core/crypto/ECTool.java Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">BSI FIDELIO eService
   &#160;<span id="projectnumber">1</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_e_c_tool_8java_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ECTool.java</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_e_c_tool_8java.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">package </span>de.bund.bsi.fidelio.poc.core.crypto;</div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">import</span> java.math.BigInteger;</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">import</span> java.security.NoSuchAlgorithmException;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">import</span> java.security.SecureRandom;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">import</span> java.security.spec.ECFieldFp;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">import</span> java.security.spec.ECParameterSpec;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">import</span> java.security.spec.ECPoint;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">import</span> java.security.spec.EllipticCurve;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1persoapp.html">persoapp</a>.<a class="code" href="namespacede_1_1persoapp_1_1core.html">core</a>.<a class="code" href="namespacede_1_1persoapp_1_1core_1_1util.html">util</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1persoapp.html">persoapp</a>.<a class="code" href="namespacede_1_1persoapp_1_1core.html">core</a>.<a class="code" href="namespacede_1_1persoapp_1_1core_1_1util.html">util</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html">   20</a></span>&#160;<span class="keyword">public</span> <span class="keyword">class </span><a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html">ECTool</a> {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">private</span> <span class="keyword">static</span> <span class="keyword">final</span> BigInteger ZERO = BigInteger.ZERO;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">private</span> <span class="keyword">static</span> <span class="keyword">final</span> BigInteger ONE = BigInteger.ONE;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">private</span> <span class="keyword">static</span> <span class="keyword">final</span> BigInteger[] INFINITY = <span class="keyword">new</span> BigInteger[] { null, null, null };</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> BigInteger Q;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> BigInteger A;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> BigInteger[][] preComp;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">private</span> SecureRandom random;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> BigInteger N;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> <span class="keywordtype">int</span> nBitLength;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acc6de5c5d0c133946d881e24baf68893">   57</a></span>&#160;    <span class="keyword">public</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acc6de5c5d0c133946d881e24baf68893">ECTool</a>(<span class="keyword">final</span> ECParameterSpec ecSpec) {</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordflow">try</span> {</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            <span class="comment">// getInstanceStrong() will use /dev/random, not /dev/urandom and</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            <span class="comment">// block until enough random is available</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            this.random = SecureRandom.getInstance(<span class="stringliteral">&quot;SHA1PRNG&quot;</span>);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        } <span class="keywordflow">catch</span> (<span class="keyword">final</span> NoSuchAlgorithmException e) {</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            System.out.println(e.getMessage());</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            this.random = <span class="keyword">new</span> SecureRandom();</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keyword">final</span> EllipticCurve curve = ecSpec.getCurve();</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        this.Q = ((ECFieldFp) curve.getField()).getP();</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        this.A = curve.getA();</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        this.N = ecSpec.getOrder();</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        this.nBitLength = this.N.bitLength();</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        this.preComp = <span class="keyword">new</span> BigInteger[16][];</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keyword">final</span> ECPoint G = ecSpec.getGenerator();</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        this.preComp[0] = <span class="keyword">new</span> BigInteger[] { G.getAffineX(), G.getAffineY(), ONE };</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        preComputation(this.preComp);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    }</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> <span class="keywordtype">void</span> preComputation(<span class="keyword">final</span> BigInteger[][] pcData) {</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keyword">final</span> BigInteger[] Ptwice = <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a38e2af668fc3ea7f0cff6e62c2b1f5c3">multiplyBy2NEW</a>(pcData[0]);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; pcData.length; i++) {</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            pcData[i] = add(Ptwice, pcData[i - 1]);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        }</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    }</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keyword">private</span> byte[] reduceBigInt(<span class="keyword">final</span> BigInteger i) {</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        byte[] result = i.toByteArray();</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keywordflow">while</span> (result[0] == 0) {</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            result = <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(result, 1, result.length - 1);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        }</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keywordflow">return</span> result;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    }</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keyword">private</span> byte[] encodePoint(<span class="keyword">final</span> BigInteger[] p) {</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;                .<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a9ceb79f761d025ca06139ee6935420c6">arrayconcat</a>(<span class="keyword">new</span> byte[] { 0x04 }, <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a9ceb79f761d025ca06139ee6935420c6">arrayconcat</a>(reduceBigInt(p[0]), reduceBigInt(p[1])));</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a7626e9a4d0226e3be39d238028ca5974">  129</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">final</span> byte[] <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a7626e9a4d0226e3be39d238028ca5974">toPublicKey</a>(<span class="keyword">final</span> BigInteger privKey) {</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="keywordflow">return</span> encodePoint(<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acf799c526ce301aa3c432c77e28f5866">fastMultiply</a>(privKey));</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    }</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="comment">// sign</span></div><div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a84722d69cec90419526bd98cd52b4f71">  135</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">final</span> byte[] <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a84722d69cec90419526bd98cd52b4f71">sign</a>(<span class="keyword">final</span> BigInteger key, <span class="keyword">final</span> byte[] hash) {</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        BigInteger e = <span class="keyword">new</span> BigInteger(1, hash);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">if</span> (hash.length * 8 - <span class="keyword">this</span>.nBitLength &gt; 0) {</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            e = e.shiftRight(hash.length * 8 - <span class="keyword">this</span>.nBitLength);</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        }</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        BigInteger k, r;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordflow">do</span> { <span class="comment">// r = x-axis of G&#39;[x, y, z] = G[x, y, z] * k</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            <span class="keywordflow">do</span> { <span class="comment">// k</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                k = <span class="keyword">new</span> BigInteger(this.nBitLength, this.random);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            } <span class="keywordflow">while</span> (ZERO.equals(k) || k.compareTo(this.N) &gt;= 0 || !k.gcd(this.N).equals(ONE));</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            r = <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acf799c526ce301aa3c432c77e28f5866">fastMultiply</a>(k)[0];</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        } <span class="keywordflow">while</span> (ZERO.equals(r));</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="comment">// (r*key + e) / k = (P[x] * key + e) / k = ((k * G)[x] * key + e) / k</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keyword">final</span> BigInteger s = key.multiply(r).add(e).multiply(k.modInverse(<span class="keyword">this</span>.N)).mod(this.N);</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(0x30, <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a9ceb79f761d025ca06139ee6935420c6">arrayconcat</a>(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(0x02, r.toByteArray()),</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;                <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(0x02, <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">concat</a>(s.toByteArray()))));</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    }</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment">     * The following implementation uses modified Jacobian coordinates somewhat inspired from</span></div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="comment">     * http://point-at-infinity.org/ecc/Prime_Curve_Standard_Projective_Coordinates.html but without returning aZ&#39;^4, a</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment">     * point is a therefore a triple, not a quadruple. aZ^4 is calculated because this couple of multiplications turned</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment">     * out to be quite fast.</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="keyword">private</span> <span class="keyword">static</span> <span class="keywordtype">int</span>[] determineNaf(<span class="keyword">final</span> BigInteger e, <span class="keyword">final</span> <span class="keywordtype">int</span> w, <span class="keyword">final</span> <span class="keywordtype">int</span> b) {</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keyword">final</span> <span class="keywordtype">int</span> power2wi = 1 &lt;&lt; w;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="keywordtype">int</span> j, u;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keyword">final</span> <span class="keywordtype">int</span>[] N = <span class="keyword">new</span> <span class="keywordtype">int</span>[b + 1];</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        BigInteger c = e.abs();</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keyword">final</span> <span class="keywordtype">int</span> s = e.signum();</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        j = 0;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keywordflow">while</span> (c.compareTo(BigInteger.ZERO) &gt; 0) {</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            <span class="keywordflow">if</span> (c.testBit(0)) {</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                u = c.intValue() &amp; (power2wi &lt;&lt; 1) - 1;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                <span class="keywordflow">if</span> ((u &amp; power2wi) != 0) {</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                    u = u - (power2wi &lt;&lt; 1);</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                }</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                c = c.subtract(BigInteger.valueOf(u));</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                u = 0;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            }</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            N[j++] = s &gt; 0 ? u : -u;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            c = c.shiftRight(1);</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        }</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="comment">// fill with zeros</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keywordflow">while</span> (j &lt;= b) {</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            N[j++] = 0;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        }</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keywordflow">return</span> N;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    }</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acf799c526ce301aa3c432c77e28f5866">  217</a></span>&#160;    <span class="keyword">public</span> BigInteger[] <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acf799c526ce301aa3c432c77e28f5866">fastMultiply</a>(<span class="keyword">final</span> BigInteger k) {</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keyword">final</span> <span class="keywordtype">int</span>[] N = determineNaf(k, 5, k.bitLength());</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        BigInteger[] r = INFINITY;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keyword">final</span> <span class="keywordtype">int</span> l = N.length - 1;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = l; i &gt;= 0; i--) {</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;            r = <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a38e2af668fc3ea7f0cff6e62c2b1f5c3">multiplyBy2NEW</a>(r);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;            <span class="keyword">final</span> <span class="keywordtype">int</span> index = N[i];</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            <span class="keywordflow">if</span> (index &gt; 0) {</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                r = add(r, this.preComp[index - 1 &gt;&gt; 1]);</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (index &lt; 0) {</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                r = subtract(r, this.preComp[-index - 1 &gt;&gt; 1]);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            }</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        }</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        BigInteger x = r[0], y = r[1], z = r[2];</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        z = z.modInverse(this.Q);</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        <span class="keyword">final</span> BigInteger z2 = z.multiply(z);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        z = z.multiply(z2);</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        x = x.multiply(z2);</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        y = y.multiply(z);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="comment">// coordinates are affine, that&#39;s why Z = 1</span></div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">new</span> BigInteger[] { x.mod(this.Q), y.mod(this.Q), ONE };</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    }</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    <span class="keyword">private</span> BigInteger[] add(<span class="keyword">final</span> BigInteger[] a, <span class="keyword">final</span> BigInteger[] b) {</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keywordflow">if</span> (a[0] == null &amp;&amp; a[1] == null) {</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            <span class="keywordflow">return</span> b;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        }</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="keywordflow">if</span> (b[0] == null &amp;&amp; b[1] == null) {</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;            <span class="keywordflow">return</span> a;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        }</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        <span class="keyword">final</span> BigInteger aX = a[0], aY = a[1], aZ = a[2];</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <span class="keyword">final</span> BigInteger bX = b[0], bY = b[1], bZ = b[2];</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        BigInteger U1, S1, U2, S2;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="comment">// point B is affine</span></div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keywordflow">if</span> (bZ.equals(ONE)) {</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            <span class="comment">// U1 = aX*bZ^2</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            U1 = aX;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            <span class="comment">// S1 = aY*bZ^3</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            S1 = aY;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            <span class="keyword">final</span> BigInteger bZ2 = bZ.multiply(bZ).mod(this.Q);</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            <span class="comment">// U1 = aX*bZ^2</span></div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            U1 = aX.multiply(bZ2).mod(this.Q);</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            <span class="comment">// S1 = aY*bZ^3</span></div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;            S1 = aY.multiply(bZ2.multiply(bZ).mod(this.Q)).mod(this.Q);</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        }</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        <span class="comment">// point A is affine</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keywordflow">if</span> (aZ.equals(ONE)) {</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            <span class="comment">// U2 = bX*aZ^2</span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            U2 = bX;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            <span class="comment">// S2 = bY*aZ^3</span></div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            S2 = bY;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;            <span class="keyword">final</span> BigInteger aZ2 = aZ.multiply(aZ).mod(this.Q);</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            <span class="comment">// U2 = bX*aZ^2</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            U2 = bX.multiply(aZ2).mod(this.Q);</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            <span class="comment">// S2 = bY*aZ^3</span></div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            S2 = bY.multiply(aZ2.multiply(aZ).mod(this.Q)).mod(this.Q);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        }</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        <span class="comment">// H = bX*aZ^2 - aX*bZ^2</span></div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        <span class="keyword">final</span> BigInteger H = U2.subtract(U1);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        <span class="comment">// r = bY*aZ^3 - aY*bZ^3</span></div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        <span class="keyword">final</span> BigInteger r = S2.subtract(S1);</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <span class="keywordflow">if</span> (H.equals(ZERO)) {</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            <span class="keywordflow">if</span> (r.equals(ZERO)) {</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                <span class="keywordflow">return</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a38e2af668fc3ea7f0cff6e62c2b1f5c3">multiplyBy2NEW</a>(a);</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;            }</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;            <span class="keywordflow">return</span> INFINITY;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        }</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="comment">// U2 = (bX*aZ^2 - aX*bZ^2)^2</span></div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        U2 = H.multiply(H).mod(this.Q);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        <span class="comment">// S2 = (bX*aZ^2 - aX*bZ^2)^3</span></div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        S2 = U2.multiply(H).mod(this.Q);</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        <span class="comment">// U2 = U1H^2</span></div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        U2 = U2.multiply(U1).mod(this.Q);</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        <span class="comment">// x = r^2 - S2 - 2U2</span></div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        <span class="keyword">final</span> BigInteger x = r.multiply(r).mod(this.Q).subtract(S2).subtract(U2.add(U2));</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="comment">// y = r(U2 - x) - S1S2</span></div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        <span class="keyword">final</span> BigInteger y = r.multiply(U2.subtract(x)).mod(this.Q).subtract(S1.multiply(S2).mod(this.Q));</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        BigInteger z;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;        <span class="comment">// z = Z1Z2H</span></div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        <span class="comment">// point A is affine</span></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;        <span class="keywordflow">if</span> (aZ.equals(ONE)) {</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;            <span class="comment">// point B is not affine</span></div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;            <span class="keywordflow">if</span> (!bZ.equals(ONE)) {</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;                z = bZ.multiply(H);</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;                <span class="comment">// both are affine</span></div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;                z = H;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            }</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!bZ.equals(ONE)) {</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;            U1 = aZ.multiply(bZ).mod(this.Q);</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;            z = U1.multiply(H);</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;            z = aZ.multiply(H);</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;        }</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">new</span> BigInteger[] { x.mod(this.Q), y.mod(this.Q), z.mod(this.Q) };</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    }</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    <span class="keyword">private</span> BigInteger[] subtract(<span class="keyword">final</span> BigInteger[] a, <span class="keyword">final</span> BigInteger[] b) {</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        <span class="keywordflow">return</span> add(a, <span class="keyword">new</span> BigInteger[] { b[0], b[1].negate(), b[2] });</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    }</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;</div><div class="line"><a name="l00370"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a38e2af668fc3ea7f0cff6e62c2b1f5c3">  370</a></span>&#160;    <span class="keyword">public</span> BigInteger[] <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a38e2af668fc3ea7f0cff6e62c2b1f5c3">multiplyBy2NEW</a>(<span class="keyword">final</span> BigInteger[] p) {</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        <span class="keyword">final</span> BigInteger pX = p[0], pY = p[1], pZ = p[2];</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        <span class="keywordflow">if</span> (pX == null &amp;&amp; pY == null) { <span class="comment">// is infinity</span></div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;            <span class="comment">// Twice identity element (point at infinity) is identity</span></div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;            <span class="keywordflow">return</span> p;</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        }</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        <span class="keywordflow">if</span> (pY.signum() == 0) {</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;            <span class="comment">// if y1 == 0, then (x1, y1) == (x1, -y1)</span></div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;            <span class="comment">// and hence this = -this and thus 2(x1, y1) == infinity</span></div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;            <span class="keywordflow">return</span> INFINITY; <span class="comment">// that&#39;s infinity</span></div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;        }</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        <span class="comment">// z = Y^2</span></div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;        BigInteger z = pY.multiply(pY).mod(this.Q);</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;        <span class="comment">// S = 4XY^2</span></div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        BigInteger S = pX.multiply(z).mod(this.Q);</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;        S = S.add(S);</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;        S = S.add(S);</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;        <span class="comment">// M = 3X^2 + a(Z^2)^2</span></div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;        BigInteger pAZ4 = this.A;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        <span class="comment">// point is not affine</span></div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        <span class="keywordflow">if</span> (!pZ.equals(ONE)) {</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;            pAZ4 = pZ.multiply(pZ).mod(this.Q);</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;            pAZ4 = this.A.multiply(pAZ4.multiply(pAZ4).mod(this.Q)).mod(this.Q);</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        }</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;        BigInteger y = pX.multiply(pX).mod(this.Q);</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;        <span class="keyword">final</span> BigInteger M = y.add(y).add(y).add(pAZ4); <span class="comment">// 3X^2+aZ^4</span></div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;        <span class="comment">// T = x = -2S + M^2</span></div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;        <span class="keyword">final</span> BigInteger x = M.multiply(M).mod(this.Q).subtract(S.add(S));</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        <span class="comment">// y = -8Y^4 + M(S - T)</span></div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;        y = z.multiply(z).mod(this.Q);</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;        BigInteger U = y.add(y); <span class="comment">// 2Y^4</span></div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        z = U.add(U);</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        U = z.add(z); <span class="comment">// 8Y^4</span></div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        y = M.multiply(S.subtract(x)).mod(this.Q).subtract(U);</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;        <span class="comment">// Z = 2Y</span></div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;        <span class="keywordflow">if</span> (!pZ.equals(ONE)) {</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;            z = pY.multiply(pZ).mod(this.Q);</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;        } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;            z = pY;</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;        }</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        z = z.add(z);</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">new</span> BigInteger[] { x.mod(this.Q), y.mod(this.Q), z.mod(this.Q) };</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;    }</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;}</div><div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool_html_acf799c526ce301aa3c432c77e28f5866"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acf799c526ce301aa3c432c77e28f5866">de.bund.bsi.fidelio.poc.core.crypto.ECTool.fastMultiply</a></div><div class="ttdeci">BigInteger [] fastMultiply(final BigInteger k)</div><div class="ttdef"><b>Definition:</b> <a href="_e_c_tool_8java_source.html#l00217">ECTool.java:217</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">de.persoapp.core.util.TLV</a></div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00062">TLV.java:62</a></div></div>
<div class="ttc" id="namespacede_1_1persoapp_html"><div class="ttname"><a href="namespacede_1_1persoapp.html">de.persoapp</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool_html"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html">de.bund.bsi.fidelio.poc.core.crypto.ECTool</a></div><div class="ttdef"><b>Definition:</b> <a href="_e_c_tool_8java_source.html#l00020">ECTool.java:20</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a42cd4a5478a3d772c23584433feee5b7"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">de.persoapp.core.util.TLV.concat</a></div><div class="ttdeci">static final byte [] concat(final byte[] b1, final int offset1, final int length1, final byte[] b2, final int offset2, final int length2)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00545">TLV.java:545</a></div></div>
<div class="ttc" id="namespacede_1_1persoapp_1_1core_html"><div class="ttname"><a href="namespacede_1_1persoapp_1_1core.html">de.persoapp.core</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html_a4a210e2647c65a7c2fc7d901dc6b5f45"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">de.persoapp.core.util.ArrayTool.subArray</a></div><div class="ttdeci">static final byte [] subArray(final byte[] b1, final int offset, final int length)</div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00136">ArrayTool.java:136</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool_html_a84722d69cec90419526bd98cd52b4f71"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a84722d69cec90419526bd98cd52b4f71">de.bund.bsi.fidelio.poc.core.crypto.ECTool.sign</a></div><div class="ttdeci">final byte [] sign(final BigInteger key, final byte[] hash)</div><div class="ttdef"><b>Definition:</b> <a href="_e_c_tool_8java_source.html#l00135">ECTool.java:135</a></div></div>
<div class="ttc" id="namespacede_html"><div class="ttname"><a href="namespacede.html">de</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a48478c0bb53bccd76d8c488352c4f849"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">de.persoapp.core.util.TLV.build</a></div><div class="ttdeci">static byte [] build(final int tagID, final byte[] data)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00198">TLV.java:198</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool_html_a38e2af668fc3ea7f0cff6e62c2b1f5c3"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a38e2af668fc3ea7f0cff6e62c2b1f5c3">de.bund.bsi.fidelio.poc.core.crypto.ECTool.multiplyBy2NEW</a></div><div class="ttdeci">BigInteger [] multiplyBy2NEW(final BigInteger[] p)</div><div class="ttdef"><b>Definition:</b> <a href="_e_c_tool_8java_source.html#l00370">ECTool.java:370</a></div></div>
<div class="ttc" id="namespacede_1_1persoapp_1_1core_1_1util_html"><div class="ttname"><a href="namespacede_1_1persoapp_1_1core_1_1util.html">de.persoapp.core.util</a></div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00049">ArrayTool.java:49</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html_a9ceb79f761d025ca06139ee6935420c6"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a9ceb79f761d025ca06139ee6935420c6">de.persoapp.core.util.ArrayTool.arrayconcat</a></div><div class="ttdeci">static final byte [] arrayconcat(final byte[] b1, final int offset1, final int length1, final byte[] b2, final int offset2, final int length2)</div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00091">ArrayTool.java:91</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool_html_acc6de5c5d0c133946d881e24baf68893"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#acc6de5c5d0c133946d881e24baf68893">de.bund.bsi.fidelio.poc.core.crypto.ECTool.ECTool</a></div><div class="ttdeci">ECTool(final ECParameterSpec ecSpec)</div><div class="ttdef"><b>Definition:</b> <a href="_e_c_tool_8java_source.html#l00057">ECTool.java:57</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">de.persoapp.core.util.ArrayTool</a></div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00059">ArrayTool.java:59</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool_html_a7626e9a4d0226e3be39d238028ca5974"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_e_c_tool.html#a7626e9a4d0226e3be39d238028ca5974">de.bund.bsi.fidelio.poc.core.crypto.ECTool.toPublicKey</a></div><div class="ttdeci">final byte [] toPublicKey(final BigInteger privKey)</div><div class="ttdef"><b>Definition:</b> <a href="_e_c_tool_8java_source.html#l00129">ECTool.java:129</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_821818eb74338e35a65f6fbb6b6439d5.html">de</a></li><li class="navelem"><a class="el" href="dir_aed0f333c467b9813cdb4ca5bf21300d.html">bund</a></li><li class="navelem"><a class="el" href="dir_346851372df3dc57f10a0e34e7cdb6f5.html">bsi</a></li><li class="navelem"><a class="el" href="dir_1d637c5f431828e7699998ba10862327.html">fidelio</a></li><li class="navelem"><a class="el" href="dir_8ebefae09cc9186ac018f5e9efaf9a56.html">poc</a></li><li class="navelem"><a class="el" href="dir_24b4b472e31b9b4fd29b4f392ea173d2.html">core</a></li><li class="navelem"><a class="el" href="dir_506b877837eeef05138d4539e24b1ec3.html">crypto</a></li><li class="navelem"><a class="el" href="_e_c_tool_8java.html">ECTool.java</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
